local _self
local inputLock = true
local function Input(params)
  local function SoundMessage(btn)
    if btn == 'Back' then
      MESSAGEMAN:Broadcast('PlaySound', {
          Sound = 'Back',
      })
    elseif btn == 'Select' then
    elseif btn == 'Up' then
		elseif btn == 'Down' then
		elseif btn == 'Left' then
      MESSAGEMAN:Broadcast('PlaySound', {
          Sound = 'Change',
      })
		elseif btn == 'Right' then
      MESSAGEMAN:Broadcast('PlaySound', {
          Sound = 'Change',
      })
        -- 確定
		elseif btn == 'Start' then
      MESSAGEMAN:Broadcast('PlaySound', {
          Sound = 'Start',
      })
		end
  end

	if params.type == 'InputEventType_FirstPress'
	    or params.type == 'InputEventType_Repeat' then
        SoundMessage(params.button)
	end
  
	if params.type == 'InputEventType_FirstPress' then
    if params.DeviceInput and params.DeviceInput.button then
      if params.DeviceInput.button == 'DeviceButton_s' then
        SCREENMAN:SetNewScreen('ScreenSelectMusic')
      end
    end
  end
end

local function SoundActor()
  return Def.ActorFrame({
    LoadActor(THEME:GetPathS('MusicWheel', 'change'))..{
      PlaySoundMessageCommand = function(self, params)
        if params.Sound == 'Change' then
          self:play()
        end
      end,
    },
    LoadActor(THEME:GetPathS('Common', 'value'))..{
      PlaySoundMessageCommand = function(self, params)
        if params.Sound == 'Cursor' then
          self:play()
        end
      end,
    },
    LoadActor(THEME:GetPathS('Common', 'start'))..{
      PlaySoundMessageCommand = function(self, params)
        if params.Sound == 'Start' then
          self:play()
        end
      end,
    },
    LoadActor(THEME:GetPathS('Common', 'cancel'))..{
      PlaySoundMessageCommand = function(self, params)
        if params.Sound == 'Back' then
          self:play()
        end
      end,
    },
  })
end

return Def.ActorFrame({
  CodeCommand = function(self, params)
    if not inputLock then
      if params.Name == 'Back' then
        self:playcommand('Back')
      end
    end
  end,
  OnCommand = function(self)
    self:sleep(0.5)
    self:queuecommand('UnlockKey')
  end,
  UnlockKeyCommand = function(self)
    inputLock = false
  end,
  BackCommand = function(self)
    inputLock = true
    self:playcommand('PlaySound', {Sound = 'Back'})
    self:sleep(0.5)
    self:queuecommand('BackScreen')
  end,
  BackScreenCommand = function(self)
    SCREENMAN:SetNewScreen('ScreenSelectMusic')
  end,
  ToEasyDifficultyMessageCommand = function(self)
  end,
  ToHardDifficultyMessageCommand = function(self)
  end,
})