local pn, tc = ...
local screen
local life
local battery
local tmpLife = 0

local tcConfig = LoadActor(tc..'/config.lua')

return Def.ActorFrame({
  OnCommand = function(self)
      if W_PLAYER:IsEnabled(pn) then
          screen  = SCREENMAN:GetTopScreen()
          life    = screen:GetLifeMeter(pn) or nil
          battery = life.GetTotalLives and life:GetTotalLives() or nil
          self:sleep(0.1)
          self:queuecommand('AfterOn')
      end
  end,
  ScreenUpdateMessageCommand = function(self, params)
      local curLife = life and life:GetLife() or 0
      if tmpLife == curLife then return end
      tmpLife = curLife
      self:playcommand('ChangedPlayerLife', {
          Player = pn,
          Life   = life and curLife or 0,
          Danger = life
              and (battery and (life:GetLivesLeft() == 1) or life:IsInDanger())
              or false,
      })
  end,
  LoadActor(THEME:GetPathO('', 'Gimmick/_frame/_'..tcConfig.Type..'/default.lua'), pn, tc, tcConfig),
})